/* --- BTTestSub.cpp --- */
/* --- Sub routine for BTTest --- */

#include "stdafx.h"
#include "BTTest.h"
#include "BTTestSub.h"
#include "BTLib.h"

#define RECVDATASIZE 4096
#define RECVTIMEOUT 20000

/* --- O[oϐ --- */
BOOL bCancel;

/* --- Oϐ --- */
extern BTST_DEVICEINFO stDeviceInfo;
extern HANDLE hPort, hFile;
extern UCHAR *SendData;
extern DWORD dwFileSize;
extern BOOL bDir;

/* --- Ή`Tu[` --- */
LRESULT CALLBACK DispSendTest(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;

	switch (message)
	{
		case WM_INITDIALOG:
			// trying to center the About dialog
			if (GetWindowRect(hDlg, &rt1)) {
				GetClientRect(GetParent(hDlg), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
				
				// if the About box is larger than the physical screen 
				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hDlg, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}

			bCancel = FALSE;
			AfxBeginThread((AFX_THREADPROC)DoSendTest, (LPVOID)hDlg);	//Xbh֐Ă
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDCANCEL) 
			{
			//	EndDialog(hDlg, LOWORD(wParam));
				bCancel = TRUE;
				return TRUE;
			}
			break;
	}
    return FALSE;
}

LRESULT CALLBACK DispRecvTest(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;

	switch (message)
	{
		case WM_INITDIALOG:
			// trying to center the About dialog
			if (GetWindowRect(hDlg, &rt1)) {
				GetClientRect(GetParent(hDlg), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
				
				// if the About box is larger than the physical screen 
				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hDlg, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}

			bCancel = FALSE;
			AfxBeginThread((AFX_THREADPROC)DoRecvTest, (LPVOID)hDlg);	//Xbh֐Ă
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDCANCEL) 
			{
			//	EndDialog(hDlg, LOWORD(wParam));
				bCancel = TRUE;
				return TRUE;
			}
			break;
	}
    return FALSE;
}

LRESULT CALLBACK DispSendRecvTest(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;

	switch (message)
	{
		case WM_INITDIALOG:
			// trying to center the About dialog
			if (GetWindowRect(hDlg, &rt1)) {
				GetClientRect(GetParent(hDlg), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
				
				// if the About box is larger than the physical screen 
				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hDlg, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}

			bCancel = FALSE;
			AfxBeginThread((AFX_THREADPROC)DoSendRecvTest, (LPVOID)hDlg);	//Xbh֐Ă
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDCANCEL) 
			{
			//	EndDialog(hDlg, LOWORD(wParam));
				bCancel = TRUE;
				return TRUE;
			}
			break;
	}
    return FALSE;
}

BOOL DoSendTest(LPVOID pParam) 
{
	DWORD dwLoop = 0;
	DWORD StartTime, StopTime, dwSendNum;
	UCHAR datasize[4];
	CString szMes;
	double restime;
	BOOL bRet;

	Sleep(1000);

	//	Mf[^TCY𑗐M
	memcpy(datasize, (UCHAR *)&dwFileSize, 4);
	dwSendNum = 0;
	bRet = WriteFile(hPort, datasize, 4, &dwSendNum, NULL);
	if (bRet == 0 || dwSendNum != 4) {
		MessageBox((HWND)pParam, TEXT("Can't Send Data Size!"), TEXT("Send Test"), MB_OK | MB_ICONWARNING);
		bCancel = TRUE;
	}

	//	Mf[^TCY\
	szMes.Format(TEXT("%ld [bytes]"), dwFileSize);
	SetWindowText(GetDlgItem((HWND)pParam, IDC_SEND_SIZE), szMes);

	//	f[^MJԂ[v
	while (bCancel != TRUE) {
		Sleep(500);

		//	f[^{̂𑗐M
		dwSendNum = 0;
		StartTime = GetTickCount();
		bRet = WriteFile(hPort, SendData, dwFileSize, &dwSendNum, NULL);
		StopTime = GetTickCount();

//		if (bRet == 0 || dwFileSize != dwSendNum) {
		if (bRet == 0) {
			MessageBox((HWND)pParam, TEXT("Failed to Send Data!"), TEXT("Send Test"), MB_OK | MB_ICONWARNING);
			break;
		}

		//	ʂ\
		dwLoop ++;
		szMes.Format(TEXT("%ld"), dwLoop);
		SetWindowText(GetDlgItem((HWND)pParam, IDC_SEND_LOOP), szMes);

		restime = CalcTimeResult(StartTime, StopTime);
		szMes.Format(TEXT("%6.3f [s]"), restime);
		SetWindowText(GetDlgItem((HWND)pParam, IDC_SEND_TIME), szMes);

		szMes.Format(TEXT("%ld [bps]"), (DWORD)(dwSendNum * 8 / restime));
		SetWindowText(GetDlgItem((HWND)pParam, IDC_SEND_RATE), szMes);
		Sleep(500);
	}

	EndDialog((HWND)pParam, IDCANCEL);
	return TRUE;
}

BOOL DoRecvTest(LPVOID pParam) 
{
	DWORD dwLoop = 0;
	DWORD StartTime, StopTime, LapTime;
	DWORD dwModemStat, dwOldStat;
	DWORD dwRecvNum, dwRecvAllNum, dwDataSize;
	UCHAR tempdata[1024];
	CString szMes;
	double restime;
	BOOL bRet;
	int i;

	//	Mf[^TCYM
	i= 0;
	while (i < 4) {
		dwRecvNum = 0;
		bRet = ReadFile(hPort, &tempdata[i], 1, &dwRecvNum, NULL);
		if (bRet != 0 && dwRecvNum == 1) {
			i ++;
		}
		Sleep(1);
	}

	//	Mf[^TCY\
	memcpy((UCHAR *)&dwDataSize, tempdata, 4);
	szMes.Format(TEXT("%ld [bytes]"), dwDataSize);
	SetWindowText(GetDlgItem((HWND)pParam, IDC_RECV_SIZE), szMes);

	//	Mf[^TCY0̏ꍇ͋I
	if (dwDataSize == 0) {
		MessageBox((HWND)pParam, TEXT("Data Size Error!"), TEXT("Receive Test"), MB_OK | MB_ICONWARNING);
		bCancel = TRUE;
	}

	//	f[^MJԂ[v
	while (bCancel != TRUE) {
		Sleep(500);

		//	f[^{̂M
		dwRecvAllNum = 0;
		GetCommModemStatus(hPort, &dwOldStat);

		StartTime = GetTickCount();
		LapTime = StartTime;
		do {
			dwRecvNum = 0;
			bRet = ReadFile(hPort, tempdata, 1024, &dwRecvNum, NULL);
			if (bRet == 0) {
				MessageBox((HWND)pParam, TEXT("Failed to Receive Data!"), TEXT("Receive Test"), MB_OK | MB_ICONWARNING);
				bCancel = TRUE;
				break;
			}

			dwRecvAllNum += dwRecvNum;
			GetCommModemStatus(hPort, &dwModemStat);

			//	^CAEg
			if (dwRecvNum > 0) {
				LapTime = GetTickCount();
			}

			if (GetTickCount() - LapTime > RECVTIMEOUT) {
				MessageBox((HWND)pParam, TEXT("Timeout Error!"), TEXT("Receive Test"), MB_OK | MB_ICONWARNING);
				bCancel = TRUE;
				break;
			}
		} while (dwModemStat == dwOldStat && dwRecvAllNum < dwDataSize && bCancel != TRUE);
		StopTime = GetTickCount();

		//	ʂ\
		dwLoop ++;
		szMes.Format(TEXT("%ld"), dwLoop);
		SetWindowText(GetDlgItem((HWND)pParam, IDC_RECV_LOOP), szMes);

		restime = CalcTimeResult(StartTime, StopTime);
		szMes.Format(TEXT("%6.3f [s]"), restime);
		SetWindowText(GetDlgItem((HWND)pParam, IDC_RECV_TIME), szMes);

		szMes.Format(TEXT("%ld [bps]"), (DWORD)(dwRecvAllNum * 8 / restime));
		SetWindowText(GetDlgItem((HWND)pParam, IDC_RECV_RATE), szMes);
		Sleep(500);
	}

	EndDialog((HWND)pParam, IDCANCEL);
	return TRUE;
}

BOOL DoSendRecvTest(LPVOID pParam) 
{
	DWORD dwLoop = 0;
	DWORD StartTime, StopTime, LapTime;
	DWORD dwModemStat, dwOldStat;
	DWORD dwSendNum, dwRecvNum, dwRecvAllNum, dwRecvDataSize;
	UCHAR tempdata[RECVDATASIZE], datasize[4];
	CString szMes;
	double restime;
	BOOL bRet;
	int i;

	//	Mf[^TCY𑗐M
	memcpy(datasize, (UCHAR *)&dwFileSize, 4);
	dwSendNum = 0;
	bRet = WriteFile(hPort, datasize, 4, &dwSendNum, NULL);
	if (bRet == 0 || dwSendNum != 4) {
		MessageBox((HWND)pParam, TEXT("Can't Send Data Size!"), TEXT("Send-Receive Test"), MB_OK | MB_ICONWARNING);
		bCancel = TRUE;
	}

	//	Mf[^TCYM
	i= 0;
	while (i < 4) {
		dwRecvNum = 0;
		bRet = ReadFile(hPort, &tempdata[i], 1, &dwRecvNum, NULL);
		if (bRet != 0 && dwRecvNum == 1) {
			i ++;
		}
		Sleep(1);
	}

	//	Mf[^TCY0̏ꍇ͋I
	memcpy((UCHAR *)&dwRecvDataSize, tempdata, 4);
	if (dwRecvDataSize == 0) {
		MessageBox((HWND)pParam, TEXT("Data Size Error!"), TEXT("Send-Receive Test"), MB_OK | MB_ICONWARNING);
		bCancel = TRUE;
	}

	//	f[^MJԂ[v
	while (bCancel != TRUE) {
		Sleep(500);

		//	M[h̏ꍇ
		if (bDir == DIR_SEND) {
			//	f[^MJn
			dwSendNum = 0;
			StartTime = GetTickCount();
			bRet = WriteFile(hPort, SendData, dwFileSize, &dwSendNum, NULL);
			StopTime = GetTickCount();

			if (bRet == 0 || dwFileSize != dwSendNum) {
				MessageBox((HWND)pParam, TEXT("Failed to Send Data!"), TEXT("Send-Receive Test"), MB_OK | MB_ICONWARNING);
				break;
			}

			//	ʂ\
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_STATUS), TEXT("Send"));

			szMes.Format(TEXT("%ld [bytes]"), dwFileSize);
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_SIZE), szMes);

			dwLoop ++;
			szMes.Format(TEXT("%ld"), dwLoop);
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_LOOP), szMes);

			restime = CalcTimeResult(StartTime, StopTime);
			szMes.Format(TEXT("%6.3f [s]"), restime);
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_TIME), szMes);

			szMes.Format(TEXT("%ld [bps]"), (DWORD)(dwSendNum * 8 / restime));
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_RATE), szMes);

			//	ʐM[h؂ւ
			bDir = DIR_RECV;
		} else {	//	M[h̏ꍇ
		//	f[^{̂M
			dwRecvAllNum = 0;
			GetCommModemStatus(hPort, &dwOldStat);

			StartTime = GetTickCount();
			LapTime = StartTime;
			do {
				dwRecvNum = 0;
				bRet = ReadFile(hPort, tempdata, RECVDATASIZE, &dwRecvNum, NULL);
				if (bRet == 0) {
					MessageBox((HWND)pParam, TEXT("Failed to Receive Data!"), TEXT("Send-Receive Test"), MB_OK | MB_ICONWARNING);
					bCancel = TRUE;
					break;
				}

				dwRecvAllNum += dwRecvNum;
				GetCommModemStatus(hPort, &dwModemStat);

				//	^CAEg
				if (dwRecvNum > 0) {
					LapTime = GetTickCount();
				}

				if (GetTickCount() - LapTime > RECVTIMEOUT) {
					MessageBox((HWND)pParam, TEXT("Timeout Error!"), TEXT("Send-Receive Test"), MB_OK | MB_ICONWARNING);
					bCancel = TRUE;
					break;
				}
			} while (dwModemStat == dwOldStat && dwRecvAllNum < dwRecvDataSize && bCancel != TRUE);
			StopTime = GetTickCount();

			//	ʂ\
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_STATUS), TEXT("Receive"));

			szMes.Format(TEXT("%ld [bytes]"), dwRecvAllNum);
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_SIZE), szMes);

			dwLoop ++;
			szMes.Format(TEXT("%ld"), dwLoop);
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_LOOP), szMes);

			restime = CalcTimeResult(StartTime, StopTime);
			szMes.Format(TEXT("%6.3f [s]"), restime);
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_TIME), szMes);

			szMes.Format(TEXT("%ld [bps]"), (DWORD)(dwRecvAllNum * 8 / restime));
			SetWindowText(GetDlgItem((HWND)pParam, IDC_SENDRECV_RATE), szMes);

			//	ʐM[h؂ւ
			bDir = DIR_SEND;
		}

		Sleep(500);
	}

	EndDialog((HWND)pParam, IDCANCEL);
	return TRUE;
}

double CalcTimeResult(DWORD StartTime, DWORD StopTime) 
{
	double result;

	if (StopTime < StartTime) {
		result = (double)(StopTime - StartTime) / 1000.0;
	} else {
		result = (double)(StopTime - StartTime) / 1000.0;
	}

	return result;
}

void SetPortParam(HANDLE hSeri) 
{
	DCB seri;
	COMMTIMEOUTS tout;

	/* --- COM|[gʐMp[^ݒ --- */

	GetCommState(hSeri, &seri);

	seri.BaudRate = 115200;
	seri.Parity = NOPARITY;
	seri.ByteSize = 8;
	seri.StopBits = ONESTOPBIT;

	seri.fOutX = FALSE;
	seri.fInX = FALSE;
	seri.fOutxCtsFlow = FALSE;
	seri.fOutxDsrFlow = FALSE;
	seri.fDsrSensitivity = FALSE;
	seri.fDtrControl = DTR_CONTROL_DISABLE;
	seri.fRtsControl = RTS_CONTROL_DISABLE;

	SetCommState(hSeri, &seri);

	/* --- COM|[g^CAEgԐݒ --- */

/*	GetCommTimeouts(hSeri, &tout); */

	tout.ReadIntervalTimeout = MAXDWORD;
	tout.ReadTotalTimeoutMultiplier = 0;
	tout.ReadTotalTimeoutConstant = 0;
	tout.WriteTotalTimeoutMultiplier = 0;
	tout.WriteTotalTimeoutConstant = 0;

	SetCommTimeouts(hSeri, &tout);
}

/* --- End of source file --- */
